/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;




/**
 * tmarkplugin.config.Property for a single boolean
 * @author Tomas Schackert
 *
 */
public class StringProperty extends Property{
	String key;
	String value=null;
	String defaultvalue;
	public StringProperty(PropertySource props,StringProperty src){
		super(props);
		set(src);
		
	}
	public StringProperty(PropertySource props,String key,String defaultvalue){
		super(props);
		this.key=key;
		this.defaultvalue=defaultvalue;
	}
	public StringProperty(String value,String defaultvalue){
		super(null);
		this.key=null;
		this.value=value;
		this.defaultvalue=defaultvalue;
	}
	private void load(){
		value=this.getProperty(key,defaultvalue);
	}
	public String get(){
		if (value==null) load();
		return value;
	}
	public void set(String v){
		if (v.equals(this.value))return;
		this.setProperty(key,this.value=v);
		fireChanged();
	}
	public void set(StringProperty src){
		this.key=src.key;
		this.value=src.value;
		this.defaultvalue=src.defaultvalue;
		fireChanged();
	}
	/**
	 * @see tmarkplugin.data.Property#reset()
	 */
	public void reset() {
		set(defaultvalue);
	}
}
